
--------------------------------------------------------
-- Defines
--------------------------------------------------------
local _version = "0.9"
local _allied_coalition = "blue"
local _eni_coalition = "red"

local _spawnPrefix = "SPAWN"
local _zoneHome = "HOMEPLATE"
local _commanderUnit = "HQ"

--------------------------------------------------------
-- Internal datas
--------------------------------------------------------
local all_as_groups = {}
local all_aa_groups = {}
local all_am_groups = {}
local all_zones = {}
local all_ope = {}
local all_players = SET_GROUP:New():FilterCoalitions( _allied_coalition ):FilterPrefixes("3rd-"):FilterStart()
local all_clients = SET_CLIENT:New():FilterCoalitions(_allied_coalition):FilterStart()
local EventHandler1 = EVENTHANDLER:New()
local _allied_side
local _mis_trainer
local _rootMenu
local _mistrain_menu = nil

zoneInfos = {
--            Alpha = {
--              Type = { "AS", "AA", "AM" }
--              , Freq = "V15"
--              , Description = ""
--              , Color = "RED"
--            }, 
}
opeInfos = {
--              , Freq = "V15"
--              , Description = ""
}
--------------------------------------------------------
-- API FOR MISSION
--------------------------------------------------------
--
-- registerZone( "Alpha", {"AS"},"V15","Plaine, entre Sukhumi et Zugdidi","RED" )

function registerZone( zoneName, type, freq, descr, color )
    all_zones[zoneName] = { Freq=freq, Type=type, Description=descr, Color=color, Index=0 }
end
function registerOpe( zoneName, descr )
    all_ope[zoneName] = { Description=descr }
end

function registerAWACS( groupName )
end
--------------------------------------------------------
-- Internal func def
--------------------------------------------------------
--------------------------------------------------------
-- Main Func def
--------------------------------------------------------
--------------------------------------------------------
function dart_init_groups()
    --MESSAGE:New("INIT GROUPS"):ToAll()
    local _aaGroups = SET_GROUP:New():FilterCoalitions(_eni_coalition):FilterPrefixes(_spawnPrefix):FilterCategories({"plane", "helicopter"}):FilterOnce()
    local _asGroups = SET_GROUP:New():FilterCoalitions(_eni_coalition):FilterPrefixes(_spawnPrefix):FilterCategoryGround():FilterOnce()
    local _amGroups = SET_GROUP:New():FilterCoalitions(_eni_coalition):FilterPrefixes(_spawnPrefix):FilterCategoryShip():FilterOnce()

    -- Get all available spawn objects
    _aaGroups:ForEachGroup( 
      function( _group )
          all_aa_groups[#all_aa_groups+1] = _group:GetName()
      end )
    _asGroups:ForEachGroup(
      function( _group )
          all_as_groups[#all_as_groups+1] = _group:GetName()
      end )
    _amGroups:ForEachGroup(
      function( _group )
          all_am_groups[#all_am_groups+1] = _group:GetName()
      end )
    MESSAGE:New("FOUND " .. #all_zones .. " Zones and " .. #all_ope .. " operations"):ToAll()
    MESSAGE:New(" -GROUPS A/S:" .. #all_as_groups .. " A/A:" .. #all_aa_groups .. " A/M:" .. #all_am_groups):ToAll()
end
--------------------------------------------------------
function dart_init_hq(kz)
    -- Assign tasks to Clients
    local _zone = all_zones[kz]
    
    --MESSAGE:New("Load zone " .. kz):ToAll()

    local _zO = ZONE:New(kz)
    local HQ = SPAWN:NewWithAlias( _commanderUnit, "HQ_" .. kz )
      :InitLimit( 1, 10 )
      :InitRepeatOnLanding()
      :InitRandomizeZones({_zO})
      :Spawn()

    local Patrol1 = AI_PATROL_ZONE:New( _zO, 6000, 6020, 400, 500 )
    Patrol1:ManageFuel( 0.2, 60 )
    Patrol1:SetControllable( HQ )
    Patrol1:__Start( 5 )
    
    function Patrol1:OnLeaveRTB( AIGroup )
      AIGroup:MessageToBlue( "Returning to base", 20 )
    end 
    
    function Patrol1:OnEnterPatrol( AIGroup )
      AIGroup:MessageToBlue( "Patrolling in zone " .. _zO:GetName() , 20 )
    end 

    _zone.CommandCenter = COMMANDCENTER:New( HQ, kz )

    --local Scoring = SCORING:New( "Score " .. kz )

    _zone.Mission = MISSION:New( _zone.CommandCenter, kz, "High", "Engagez les targets", _allied_side )
     --   :AddScoring( Scoring )

    _zone.FACSet = SET_GROUP:New():FilterPrefixes(HQ.GroupName):FilterStart()
    _zone.FACAreas = DETECTION_AREAS:New( _zone.FACSet, 1500 )
      --:FilterCategories( Unit.Category.GROUND_UNIT )
      --:SmokeDetectedZones()
      :BoundDetectedZones()
      :SetAcceptZones(_zO)
      --:SetZoneProbability( { { _zO, 1.0 } } )
    
    
--    _zone.RecceDesignation = DESIGNATE:New( _zone.CommandCenter, _zone.FACSet, all_players )
--    _zone.RecceDesignation:SetLaserCodes({1688})
        -- This sets the threat level prioritization on
--    _zone.RecceDesignation:SetThreatLevelPrioritization( true )
--    _zone.RecceDesignation:__Detect( -5 ) 
    
    MESSAGE:New(HQ.GroupName .. " est votre FAC sur " .. kz):ToCoalition(_allied_side)
    _zone.TaskDispatcher = TASK_A2G_DISPATCHER:New( _zone.Mission, all_players, _zone.FACAreas )
end

--------------------------------------------------------
function dart_init_client()
  -- Default
  SETTINGS:SetA2A_BRAA()
  SETTINGS:SetA2G_LL()
  SETTINGS:SetImperial()
    -- Assign tasks to Clients
  all_clients:ForEachClient( 
    function( MooseClient )
   
      -- Here we register the state of the client in which step he is in.
      -- We set the state of the client "ZoneStep" to 0, indicating that he is not out of the first zone.
      local function ResetClientForZone( MooseClient )
        BASE:E("Reset")
        MooseClient:SetState( MooseClient, "Zone", "" )
      end
      
      BASE:E( { "Alive Init", Client = MooseClient } )
      MooseClient:Alive( ResetClientForZone )
      
    end
  )
  
  Scheduler, SchedulerID = SCHEDULER:New( nil, 
    function ()
      local kz,_zone
      local _state = "Zone"
      for kz, _zone in pairs(all_zones) do
        local _z = ZONE:New(kz)
        all_clients:ForEachClientInZone( _z, 
          function( MooseClient )
            BASE:E( { Client = MooseClient, State = MooseClient:GetState( MooseClient, _state ) } )
            if MooseClient:GetState( MooseClient, _state ) ~= kz then
              MooseClient:SetState( MooseClient, _state, kz )
              MESSAGE:New("Vous entrez dans la zone " .. kz .. ", passez sur " .. _zone.Freq, 15, MooseClient:GetPlayerName() ):ToClient( MooseClient )
            end
          end
          )
    
        all_clients:ForEachClientNotInZone( _z, 
          function( MooseClient )
            BASE:E( { Client = MooseClient, State = MooseClient:GetState( MooseClient, _state ) } )
            if MooseClient:GetState( MooseClient, _state ) == kz then
              MooseClient:SetState( MooseClient, _state, "" )
              MESSAGE:New("Vous sortez de la zone " .. kz .. ", passez sur V2", 15, MooseClient:GetPlayerName() ):ToClient( MooseClient )
            end
          end
          )
        end
        -- HOMEPLATE
        local _ah = ZONE:New(_zoneHome)
        all_clients:ForEachClientInZone( _ah, 
          function( MooseClient )
            BASE:E( { Client = MooseClient, State = MooseClient:GetState( MooseClient, _state ) } )
            if MooseClient:GetState( MooseClient, _state ) ~= _zoneHome then
              MooseClient:SetState( MooseClient, _state, _zoneHome )
              MESSAGE:New("Vous entrez dans la zone de l'aeroport, passez sur V1", 15, MooseClient:GetPlayerName() ):ToClient( MooseClient )
            end
          end
          )
    
        all_clients:ForEachClientNotInZone( _ah, 
          function( MooseClient )
            BASE:E( { Client = MooseClient, State = MooseClient:GetState( MooseClient, _state ) } )
            if MooseClient:GetState( MooseClient, _state ) == _zoneHome then
              MooseClient:SetState( MooseClient, _state, "" )
              MESSAGE:New("Vous sortez de la zone de l'aeroport, passez sur V2", 15, MooseClient:GetPlayerName() ):ToClient( MooseClient )
            end
          end
          )
    end, {}, 10, 1 
    )
end
--------------------------------------------------------
function dart_n(kz, max)
  return math.random(1,max )
end
--------------------------------------------------------
function dart_activate_asm(v, kz)
  local n = dart_n( kz, 15 )
  local _zone = all_zones[kz]
  local it = SPAWN:NewWithAlias( v, kz .. _zone.Index ) 
    :InitRandomizeZones( {ZONE:New(kz)} )
    :InitRandomizeUnits(true, 500)
    :InitGrouping( n )
    :Spawn()
  _zone.Index = _zone.Index + 1
end
--------------------------------------------------------
function dart_activate_aa(v, kz)
  local _zone = all_zones[kz]
  local n = dart_n( kz, 4 )
  local CapPlane = SPAWN:NewWithAlias( v, kz .. _zone.Index ) 
    :InitRandomizeZones( {ZONE:New(kz)} )
    :InitGrouping( n )
    :Spawn()
  _zone.Index = _zone.Index + 1
  local PatrolZone = ZONE:New( kz )
  local AICapZone = AI_CAP_ZONE:New( PatrolZone, 500, 10000, 400, 1600 )
  
  AICapZone:SetControllable( CapPlane )
  AICapZone:SetEngageZone( PatrolZone ) -- Set the Engage Zone. The AI will only engage when the bogeys are within the CapEngageZone.
  AICapZone:__Start( 1 ) -- They should statup, and start patrolling in the PatrolZone.
--   AI_A2A_CAP:New(CapPlane,PatrolZone, 500, 10000, 400, 1600 ,500,2000,"RADIO"):Patrol()
end
--------------------------------------------------------
function dart_zone_info(kz)
  local _zone = all_zones[kz]
end
--------------------------------------------------------
function dart_zone_clean(kz)
  local _zone = all_zones[kz]
end
--------------------------------------------------------
function dart_activate_zone(kz)
  local _zone = all_zones[kz]
  _zone.menu:RemoveSubMenus()
  MESSAGE:New("La zone " .. kz .. " est activee"):ToCoalition(_allied_side)
  MESSAGE:New("  -> Position:" .. _zone.Description):ToCoalition(_allied_side)
  MESSAGE:New("  -> Freq:" .. _zone.Freq):ToCoalition(_allied_side)
--  MESSAGE:New("Coordonnee: "):ToCoalition(_allied_side)
  --local MenuDeActivate = MENU_COALITION_COMMAND:New( _allied_side, "DeActiver Zone", _zone.menu, dart_deactivate_as, kz )
  --local MenuInfo = MENU_COALITION_COMMAND:New( _allied_side, "Information", _zone.menu, dart_zone_info, kz )
  --local CleanInfo = MENU_COALITION_COMMAND:New( _allied_side, "Effacer", _zone.menu, dart_zone_clean, kz )
  
  local need_hq = false
  for k,v in pairs( _zone.Type ) do
      if v == "AS" then
          need_hq = true
          local _ss = MENU_COALITION:New( _allied_side, "A/S", _zone.menu )
          for kk,vv in pairs(all_as_groups) do
              MENU_COALITION_COMMAND:New( _allied_side, vv:gsub(_spawnPrefix .. "%-",""), _ss, dart_activate_asm, vv,kz )
          end
      elseif v == "AA" then
          local _ss = MENU_COALITION:New( _allied_side, "A/A", _zone.menu )
          for kk,vv in pairs(all_aa_groups) do
              MENU_COALITION_COMMAND:New( _allied_side, vv:gsub(_spawnPrefix .. "%-",""), _ss,  dart_activate_aa, vv,kz )
          end
      elseif v == "AM" then
          need_hq = true
          local _ss = MENU_COALITION:New( _allied_side, "A/M", _zone.menu )
          for kk,vv in pairs(all_am_groups) do
              MENU_COALITION_COMMAND:New( _allied_side, vv:gsub(_spawnPrefix .. "%-",""), _ss,  dart_activate_asm, vv,kz )
          end
      end
  end
  if need_hq then
    MESSAGE:New("Un aeronef est assigne et vous assigner les taches!"):ToCoalition(_allied_side)
    dart_init_hq(kz)
  end
end
--------------------------------------------------------
function dart_activate_ope(kz)
  local _ope = all_ope[kz]
  --_ope.menu:Remove()
  
  local _opeGroups = SET_GROUP:New():FilterPrefixes(kz):FilterOnce()
  _opeGroups:ForEachGroup(
    function( _group )
      SPAWN:New(_group.GroupName):Spawn()
      end
   )
    MESSAGE:New("Operation " .. kz .. "Active:"):ToCoalition(_allied_side)
    MESSAGE:New(_ope.Description):ToCoalition(_allied_side)
end
-------------------------------------------------------
function dart_activate_missiletrainer(enabled)
  if _mistrain_menu then
    _mistrain_menu:Remove()
  end
  if enabled then
      _mis_trainer = MISSILETRAINER
        :New( 200, "Trainer: Welcome to the missile training, trainee! Missiles will be fired at you. Try to evade them. Good luck!" )
        :InitMessagesOnOff(true)
        :InitAlertsToAll(true) 
        :InitAlertsHitsOnOff(true)
        :InitAlertsLaunchesOnOff(true) -- I'll put it on below ...
        :InitBearingOnOff(true)
        :InitRangeOnOff(true)
        :InitTrackingOnOff(true)
        :InitTrackingToAll(true)
        :InitMenusOnOff(true)
  
    _mistrain_menu = MENU_COALITION_COMMAND:New( _allied_side, "MissileTrainer is ON", _rootMenu, dart_activate_missiletrainer, false)
   else
    _mistrain_menu = MENU_COALITION_COMMAND:New( _allied_side, "MissileTrainer is OFF", _rootMenu, dart_activate_missiletrainer,true)
    _mist_trainer:InitTrackingOnOff(false)
        :InitMenusOnOff(false)
        :InitMenusOnOff(true)
   end
end
--------------------------------------------------------
function dart_init_menus()
  _rootMenu = MENU_COALITION:New( _allied_side, "--ADMIN--" )
  local MainMenu = MENU_COALITION:New( _allied_side, "Zones", _rootMenu )
 -- dart_activate_missiletrainer(false)
  local kz,_zone
  for kz, _zone in pairs(all_zones) do
    _zone.menu = MENU_COALITION:New( _allied_side, kz, MainMenu )
    local MenuActivate = MENU_COALITION_COMMAND:New( _allied_side, "Activer Zone", _zone.menu, dart_activate_zone, kz )
  end
    
  MainMenu = MENU_COALITION:New( _allied_side, "Operations", _rootMenu )
  local kz,_ope
    for kz, _ope in pairs(all_ope) do
      _ope.menu = MENU_COALITION:New( _allied_side, kz, MainMenu )
      local MenuActivate = MENU_COALITION_COMMAND:New( _allied_side, "Activer", _ope.menu, dart_activate_ope, kz )
    end
end
--------------------------------------------------------
-- Launch
--------------------------------------------------------
function dart_launch()
    if _allied_coalition == 'blue' then
        _allied_side = coalition.side.BLUE
    else
        _allied_side = coalition.side.RED
    end
    dart_init_groups()
    dart_init_menus()
    dart_init_client()
    MESSAGE:New("Dynamic mission by DArt v" .. _version .. " is now LOADED"):ToAll()
end
